<template>
  <div style="margin-top: 20px">
    <v-container class="fill-height">
      <v-row align="center" justify="center">
        <v-col cols="12" md="12" xl="12" sm="12">
          <v-card>
            <v-toolbar flat>
              <v-toolbar-title>
                <v-icon color="info" class="mx-2">search</v-icon> ค้นหา
              </v-toolbar-title>
              <v-spacer></v-spacer>
            </v-toolbar>
            <v-card-text> <FilterRepair v-model="obj" /> </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="orange"
                dark
                depressed
                @click="fetchRepair('reset')"
              >
                <v-icon left> search </v-icon>
                ค้นหา
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
        <v-col cols="12" md="12" xl="12" sm="12">
          <v-card>
            <v-toolbar flat>
              <v-toolbar-title>
                <v-icon color="info" class="mx-2">build</v-icon>
                รายละเอียดการซ่อม
              </v-toolbar-title>
              <v-divider class="mx-4" inset vertical></v-divider>
              <v-spacer></v-spacer>
              <v-spacer></v-spacer>
            </v-toolbar>
            <br />
            <v-card-text>
              <!-- Loading Data -->
              <Loading
                v-if="loading"
                :propLoading="loading"
                propText="กรุณารอสักครู่"
              />
              <TableRepair
                :items="items"
                :loading="loading"
                v-show="!loading"
                @update-table-parent="updateParentData"
              />
              <br />
              <!-- Pagination -->
              <div class="text-center my-1" v-if="items.length > 0">
                <v-pagination
                  v-model="page"
                  :length="length"
                  :total-visible="7"
                  circle
                  @input="handlePageChange"
                  v-show="!loading"
                ></v-pagination>
              </div>
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
import FilterRepair from "../../../components/repair/FilterRepair";
import TableRepair from "../../../components/repair/TableRepair";
import Loading from "../../../components/loading/Loading";
export default {
  components: {
    FilterRepair,
    TableRepair,
    Loading,
  },
  data() {
    return {
      items: [],
      page: 1,
      perPage: 5,
      loading: true,
      length: null,
      obj: {},
      role: this.$store.getters["auth/roleUser"],
    };
  },
  async created() {
    await this.fetchRepair();
  },
  methods: {
    async handlePageChange(value) {
      this.page = value;
      await this.fetchRepair();
    },
    updateParentData(i) {
      if (i) this.fetchRepair();
    },
    async fetchRepair(text) {
      let data = {
        page: text == undefined ? this.page : (this.page = 1),
        firstName: this.obj.firstName,
        lastName: this.obj.lastName,
        lockerCode: this.obj.lockerCode,
        accountId: localStorage.getItem("accountId"),
        Status: this.obj.status == undefined ? undefined : this.obj.status,
      };
      await this.$store.dispatch("repair/getAllRepair", data);
      let res = this.$store.getters["repair/data"];
      let loading = this.$store.getters["repair/loading"];
      this.items = res.content;
      this.length = res.length;
      this.loading = loading;
    },
  },
};
</script>

<style>
</style>